
//#define DUMP_DIZA
#define TRY_DREF

#define NONE 0xFFFFFFFF

DWORD t0;

void progress(DWORD ip)
{
  DWORD t = GetTickCount();
  if (t - t0 >= 100) // 10 times per sec
  {
    t0 = t;
    printf(".%08X\x0D", ip);
  }
}

void disasm()
{

  FLAG( pe->pe_imagebase+pe->pe_entrypointrva ) |= FLAG_NEXT | FLAG_LABEL;

#define mark(x)  if (x) FLAG( pe->pe_imagebase+(x) ) |= FLAG_LABEL;
  mark(pe->pe_importrva);
  mark(pe->pe_exportrva);
  mark(pe->pe_resourcerva);
  mark(pe->pe_tlsrva);
  mark(pe->pe_iatrva);
  mark(pe->pe_importrva+pe->pe_importsize);
  mark(pe->pe_exportrva+pe->pe_exportsize);
  mark(pe->pe_resourcerva+pe->pe_resourcesize);
  mark(pe->pe_tlsrva+pe->pe_tlssize);
  mark(pe->pe_iatrva+pe->pe_iatsize);

  for (DWORD i=0; i<(DWORD)pe->pe_numofobjects; i++)
    mark(mz->mz_neptr+0x18+pe->pe_ntheadersize+i*sizeof(PE_OBJENTRY)+8); // after sect.name

  printf(" analyzing code\n");

  t0 = GetTickCount();

  DWORD ip;

  for (ip = pe->pe_imagebase + pe->pe_imagesize - 1;
       ip > pe->pe_imagebase;
       ip--)
  {

    progress(ip);

    if ((MEMD(ip) & 0x00FFFFFF) == 0x00EC8B55)
      FLAG(ip) |= FLAG_NEXT | FLAG_LABEL;

    if (MEMW(ip) == 0x8B55)
    if (FLAG(ip) & FLAG_DREF)
      FLAG(ip) |= FLAG_NEXT | FLAG_LABEL;

    if (FLAG(ip) & FLAG_FIXUP)
    {
      if (MEMB(ip-2)==0xFF)
      if ((MEMB(ip-1)==0x15)||
          (MEMB(ip-1)==0x25)||
          (MEMB(ip-1)==0x35))
        FLAG(ip-2) |= FLAG_NEXT;
      switch (MEMB(ip-1))
      {
        case 0xA1:
        case 0xA3:
        case 0x68:
        case 0xB8: FLAG(ip-1) |= FLAG_NEXT;
                   break;
      }  // switch
    } // FLAG_FIXUP

#ifdef TRY_DREF
    if (FLAG(ip) & FLAG_DREF)
    if (!(FLAG(ip) & FLAG_NEXT))
    if (MEMB(ip) != 0x00)
    if (MEMB(ip+1) != 0x00)
    {
      DWORD j = 0;
      for (int c = 0; ; c++)
      {
        BYTE o = MEMB(ip + j);
        WORD w = MEMW(ip + j);

        if (w==0x0000)
        {
#ifdef DUMP_DIZA
          printf("ip=%08X -- data, x1\n",ip);
#endif
          break;
        }

        DWORD len = disasm_main( DATAPTR(ip+j) );
        if ((len==0)||(len==0xFFFFFFFF))
        {
#ifdef DUMP_DIZA
          printf("ip=%08X -- data, x2\n",ip);
#endif
          break;
        }

        for (DWORD i=ip+j+1; i<ip+j+len; i++)
          if (  (!(FLAG(i) & FLAG_PRESENT)) ||
                (FLAG(i) & FLAG_LABEL)  )
          {
#ifdef DUMP_DIZA
            printf("ip=%08X -- data, x3\n",ip);
#endif
            goto c2;
          }

        if (   ((o&0xF6)==0xC2)||(o==0xCF)||((w&0x38FF)==0x20FF)||(o==0xEB)||(o==0xE9)  ||
               ( FLAG(ip+j) & (FLAG_OPCODE) ) ||
               (c > 1000)   )
        {
#ifdef DUMP_DIZA
          printf("ip=%08X -- code\n",ip);
#endif
          FLAG(ip) |= FLAG_NEXT;
          break;
        }

        j += len;
      }
c2:
    } // FLAG_DREF
#endif

  }// for ip

  printf(" disassembling\n");

  for (;;)
  {

    progress(ip);

    DWORD ip0 = 0;

    for (ip = pe->pe_imagebase;
         ip < pe->pe_imagebase + pe->pe_imagesize;
         ip++)
      if (FLAG(ip) & FLAG_NEXT)
        goto c1;

    for (ip = pe->pe_imagebase;
         ip < pe->pe_imagebase + pe->pe_imagesize;
         ip++)
    if (!(FLAG(ip) & FLAG_CODE))
    {
      DWORD rel = NONE;
      BYTE  o = MEMB(ip);
      WORD  w = MEMW(ip);
//    if (((o&0xF0)==0x70)||((o&0xFC)==0xE0)||(o==0xEB))
//      rel = ip + 2 + (char)MEMB(ip + 1);
      if ((w&0xF0FF)==0x800F)
        rel = ip + 6 + (long)MEMD(ip + 2);
      if ((o==0xE8)||(o==0xE9))
        rel = ip + 5 + (long)MEMD(ip + 1);
      if (rel != NONE)
//      if (FLAG(rel) & FLAG_LABEL)
        if (FLAG(rel) & FLAG_OPCODE)
        {
#ifdef DUMP_DIZA
          printf("- found rel at %08X to %08X\n", ip, rel);
#endif
          FLAG(ip) |= FLAG_NEXT | FLAG_LABEL;
          if (ip0 == 0) ip0 = ip;
        }
    }

    if (ip0 != 0) { ip=ip0; goto c1; };

    //

    break;

c1:

#ifdef DUMP_DIZA
    printf("- NEXT found at %08X\n", ip);
#endif

    for (;;)
    {
      FLAG(ip) &= ~FLAG_NEXT;
      FLAG(ip) |= FLAG_ANALYZED;

      if ((MEMW(ip) == 0x0000) || (ip == pe->pe_imagebase))
      {
        printf("disasm: error at %08X\n", ip);
        break;
      }

      FLAG(ip) |= FLAG_OPCODE;

      DWORD len = disasm_main( DATAPTR(ip) );
      if ((len==0)||(len==0xFFFFFFFF)) break;

      for (DWORD i = 0; i < len; i++)
        FLAG(ip + i) |= FLAG_CODE;

#ifdef DUMP_DIZA
      printf("%08X: ",ip);
      for (DWORD i = 0; i < len; i++)
        printf(" %02X",MEMB(ip + i));
      printf("\n");
#endif

      DWORD nxt = ip + len;
      DWORD rel = NONE;
      BYTE  o = MEMB(ip);
      WORD  w = MEMW(ip);
      DWORD b = nxt + (char)MEMB(nxt - 1);
      DWORD d = nxt + (long)MEMD(nxt - 4);

      if (((o&0xF0)==0x70)||((o&0xFC)==0xE0)) rel=b; // jcc,jcxz,loop/z/nz
      if ((w&0xF0FF)==0x800F) rel=d;    // jcc near
      if (o==0xE8) rel=d;               // call
      if (o==0xEB) { rel=b; nxt=NONE; };// jmp short
      if (o==0xE9) { rel=d; nxt=NONE; };// jmp
      if (((o&0xF6)==0xC2)||(o==0xCF)||((w&0x38FF)==0x20FF))
        nxt=NONE; // ret/ret#/retf/retf#/iret/jmp modrm

      if (rel != NONE)
      {
#ifdef DUMP_DIZA
        printf("- rel to %08X\n", rel);
#endif
        FLAG(ip) |= FLAG_HAVEREL;
        FLAG(rel) |= FLAG_LABEL | FLAG_CREF;
        if ((FLAG(rel) & FLAG_ANALYZED) == 0)
          FLAG(rel) |= FLAG_NEXT;
#ifdef DUMP_DIZA
        else
          printf("- alredy processed\n");
#endif
      }

      if (nxt == NONE)
      {
        FLAG(ip) |= FLAG_STOP;
#ifdef DUMP_DIZA
        printf("- stop\n");
#endif
        break;
      }

      ip = nxt;

      if (ip - pe->pe_imagebase > pe->pe_imagesize)
      {
#ifdef DUMP_DIZA
        printf("- out of range\n");
#endif
        break;
      }

      if (FLAG(ip) & FLAG_CODE)
      {
#ifdef DUMP_DIZA
        printf("- alredy code\n");
#endif
        break;
      }

    } // cycle until RET
  } // main cycle

}
